# coding: utf-8

"""
    Howso API

    OpenAPI implementation for interacting with the Howso API.

    The version of the OpenAPI document: 2.0.0
    Contact: support@howso.com
    Generated by: https://openapi-generator.tech
"""


from setuptools import setup, find_namespace_packages  # noqa: H301
import os.path
import codecs


def read(rel_path):
    here = os.path.abspath(os.path.dirname(__file__))
    with codecs.open(os.path.join(here, rel_path), 'r') as fp:
        return fp.read()


def get_version(rel_path):
    for line in read(rel_path).splitlines():
        if line.startswith('__version__'):
            delim = '"' if '"' in line else "'"
            return line.split(delim)[1]
    else:
        raise RuntimeError("Unable to find version string.")


def parse_requirements(requirements):
    with open(requirements) as requirements_file:
        return [
            line.strip('\n') for line in requirements_file
            if line.strip(' \t\n') and not line.startswith('#')
        ]


NAME = "howso-openapi-client"
# To install the library, run the following
#
# python setup.py install
#
# prerequisite: setuptools
# http://pypi.python.org/pypi/setuptools


setup(
    name=NAME,
    version=get_version("howso/openapi/__init__.py"),
    description="Howso OpenAPI",
    author="Howso Incorporated",
    author_email="support@howso.com",
    url="",
    keywords=["OpenAPI", "OpenAPI-Generator", "Howso API"],
    packages=find_namespace_packages(include=['howso.*']),
    install_requires=parse_requirements('requirements.in'),
    include_package_data=True,
    license_files=('LICENSE.txt', ),
    long_description="""\
    OpenAPI implementation for interacting with the Howso API.
    """,
    classifiers=[
        'Development Status :: 3 - Alpha',
        'Intended Audience :: Science/Research',
        'Topic :: Scientific/Engineering :: Artificial Intelligence',
        'License :: OSI Approved :: GNU Affero General Public License v3',
        'Programming Language :: Python :: 3',
        'Programming Language :: Python :: 3.8',
        'Programming Language :: Python :: 3.9',
        'Programming Language :: Python :: 3.10',
        'Programming Language :: Python :: 3.11',
        'Operating System :: MacOS',
        'Operating System :: MacOS :: MacOS X',
        'Operating System :: Microsoft :: Windows',
        'Operating System :: Microsoft :: Windows :: Windows 10',
        'Operating System :: Microsoft :: Windows :: Windows 11',
        'Operating System :: POSIX :: Linux',
    ]
)
